# -*- python -*-
# $RCSfile: buttonlogger.py,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2007-06-05 18:57:31 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

import gtk
import widgetlogger

class ButtonLogger(widgetlogger.WidgetLogger):
    classes = (gtk.Button,)
    def record(self, object, signal, *args):
        if signal == 'clicked':
            return ["%s.clicked()" % self.location(object, *args)]
        return super(ButtonLogger, self).record(object, signal, *args)

class RadioButtonLogger(widgetlogger.WidgetLogger):
    classes = (gtk.RadioButton,)
    def record(self, object, signal, *args):
        if signal == 'clicked':
            # When a radio button is pressed, two 'clicked' signals
            # are sent, one to deactivate the old button and one to
            # activate the new one.  We only want to log the new one.
            if object.get_active():
                return ["%s.clicked()" % self.location(object, *args)]
            return self.ignore
        return super(RadioButtonLogger, self).record(object, signal, *args)
        
